unit Unit1;   // test

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonReset: TButton;
    ButtonRender: TButton;
    ButtonExit: TButton;
    GroupBoxMousePos: TGroupBox;
    GroupBoxTime: TGroupBox;
    Image1: TImage;
    Label_mposy: TLabel;
    Label_mposx: TLabel;
    LabelTime: TLabel;
    procedure AppInit(Sender: TObject);
    procedure ResetApp(Sender: TObject);
    procedure CloseApp(Sender: TObject);
    procedure MouseMoveInsideImage(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RenderImage(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.AppInit(Sender: TObject);   // TForm1.OnShow
begin
  LabelTime.Caption:= '';                    // RenderTime leer setzen
end;

procedure TForm1.ResetApp(Sender: TObject); // Click Reset Button
begin
 LabelTime.Caption:= 'Reset';               // Bestätigung für Reset gedrückt
end;

procedure TForm1.RenderImage(Sender: TObject);  // Start > Pixel zeichnen - Click Render Button
var
  nx,ny: integer;                         // Schleifenzähler
  tick_start: integer;                    // Zeitmessung
begin
  ButtonRender.Enabled:= false;           // ButtonRender disable
  ButtonReset.Enabled:= false;            // ButtonReset disable
  ButtonExit.Enabled:= false;             // ButtonExit disable
  Application.ProcessMessages;

  LabelTime.Font.Color:= clRed;
  LabelTime.Caption:= 'wait';             // RenderTime auf wait setzen

  tick_start:= GetTickCount64;            // Stopuhr starten

  for nx:= 0 to Image1.Width-1 do begin
    for ny:= 0 to Image1.Height-1 do begin
      Image1.canvas.pixels[nx,ny]:= clRed;
    end;
    Image1.Update;  // Grafikupdate nach jeder Pixelspalte
  end;

  LabelTime.Font.Color:= clDefault;
  LabelTime.Caption:= IntToStr(GetTickCount64 - tick_start)+ ' ms';

  ButtonRender.Enabled:= true;           // ButtonRender ensable
  ButtonReset.Enabled:= true;            // ButtonReset enable
  ButtonExit.Enabled:= true;             // ButtonExit enable
end;

procedure TForm1.CloseApp(Sender: TObject);  // Beenden - Click Exit Button
begin
  close;
end;

procedure TForm1.MouseMoveInsideImage(Sender: TObject; Shift: TShiftState; X,Y: Integer);  // Image1.OnMouseMove Ereignis
// soll mouse position anzeigen
begin
  Label_mposx.Caption:= IntToStr(X);
  Label_mposy.Caption:= IntToStr(Y);

end;

end.

